/*
 * Copyright (C) 2005-2006 Digium, Inc.
 *
 * Mark Spencer <markster@digium.com>
 *
 * All Rights Reserved
 *
 */

/*
 * See http://www.asterisk.org for more information about
 * the Asterisk project. Please do not directly contact
 * any of the maintainers of this project for assistance;
 * the project provides a web site, mailing lists and IRC
 * channels for your use.
 *
 * This program is free software, distributed under the terms of
 * the GNU General Public License Version 2 as published by the
 * Free Software Foundation. See the LICENSE file included with
 * this program for more details.
 */

#ifndef _VPM450M_H
#define _VPM450M_H

#include <linux/firmware.h>
#include "oct6100api/oct6100_api.h"
#include <linux/ioctl.h>

/* ioctl definitions */
#define TOR_B_CODE 'I'

#define	TOR_BRIDGE_INIT		_IOW (TOR_B_CODE, 100, tOCT6100_CONF_BRIDGE_OPEN)
#define	TOR_BRIDGE_CLOSE	_IOW (TOR_B_CODE, 101, tOCT6100_CONF_BRIDGE_CLOSE)
#define	TOR_BRIDGE_ADD_CHAN	_IOW (TOR_B_CODE, 102, tOCT6100_CONF_BRIDGE_CHAN_ADD)
#define	TOR_BRIDGE_REMOVE_CHAN	_IOW (TOR_B_CODE, 102, tOCT6100_CONF_BRIDGE_CHAN_REMOVE)
#define	TOR_BRIDGE_CHAN_MUTE	_IOW (TOR_B_CODE, 103, tOCT6100_CONF_BRIDGE_CHAN_MUTE)
#define	TOR_BRIDGE_CHAN_UNMUTE	_IOW (TOR_B_CODE, 104, tOCT6100_CONF_BRIDGE_CHAN_UNMUTE)
#define	TOR_BRIDGE_SET_SPEAKER	_IOW (TOR_B_CODE, 105, tOCT6100_CONF_BRIDGE_DOMINANT_SPEAKER_SET)


struct vpm450m;

/* From driver */
unsigned int oct_get_reg(void *data, unsigned int reg);
void oct_set_reg(void *data, unsigned int reg, unsigned int val);

/* From vpm450m */
struct vpm450m *init_vpm450m(void *wc, int *isalaw, int numspans, const struct firmware *firmware,int alaw);
unsigned int get_vpm450m_capacity(void *wc);
void vpm450m_setec(struct vpm450m *instance, int channel, int eclen);
void vpm450m_setdtmf(struct vpm450m *instance, int channel, int dtmfdetect, int dtmfmute);
int vpm450m_checkirq(struct vpm450m *vpm450m);
int vpm450m_getdtmf(struct vpm450m *vpm450m, int *channel, int *tone, int *start);
void release_vpm450m(struct vpm450m *instance);
int tor3_vpm_ioctl(struct vpm450m * vpm , unsigned int cmd, unsigned long data);

#endif
